'' =================================================================================================
''
''   File....... jm_dualmotor_ez_demo.spin
''   Purpose.... 
''   Author..... Jon "JonnyMac" McPhalen (aka Jon Williams)
''               Copyright (c) 2011 Jon McPhalen
''               -- see below for terms of use
''   E-mail..... jon@jonmcphalen.com
''   Started.... 
''   Updated.... 15 MAY 2011
''
'' =================================================================================================


con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal
' _xinfreq = 6_250_000                                          ' use 6.25MHz crystal

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000


con

  RX1    = 31
  TX1    = 30
  SDA    = 29
  SCL    = 28

  M0_SPD =  0
  M0_DIR =  1

  M1_SPD = -1
  M1_DIR = -1


con

  PWM_FREQ = 20_000 
  

con

   #1, HOME, GOTOXY, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR       ' PST formmatting control
  #14, GOTOX, GOTOY, CLS


obj

  term  : "fullduplexserial"
  motor : "jm_dualmotor_ez"


var


dat

Menu            byte    CLS
                byte    "=====================", CR
                byte    "Motor Speed Test     ", CR
                byte    "=====================", CR
                byte    CR
                byte    "[J]  -10  ", CR
                byte    "[j]  - 1  ", CR
                byte    "[k] Stop  ", CR                                
                byte    "[K] Stop  ", CR
                byte    "[l]  + 1  ", CR                
                byte    "[L]  +10  ", CR
                byte    0


pub main | c, speed

  term.start(RX1, TX1, %0000, 115_200)                          ' start terminal
  motor.start(M0_SPD, M0_DIR, M1_SPD, M1_DIR, PWM_FREQ)         ' start motor(s)
  pause(1)

  speed := 0
  
  repeat
    term.str(@Menu)                                             ' display menu
    term.rxflush                                                ' clear stuck keys

    term.tx(GOTOXY)                                             ' show speed
    term.tx(17)
    term.tx(1)
    rjdec(speed, 4)
    term.tx(CLREOL)

    c := term.rx
    case c
      "J":
        if (speed > -100)
          speed -= 10
          motor.setspeed(0, speed)
    
      "j":
        if (speed > -100)
          speed -= 1
          motor.setspeed(0, speed)
      
      "k", "K":
        speed := 0
        motor.setspeed(0, speed)

      "l":
        if (speed < 100)
          speed += 1
          motor.setspeed(0, speed)
          
      "L":
        if (speed < 100)
          speed += 10
          motor.setspeed(0, speed)

  
pub rjdec(val, width) | temp

  temp := val
  
  if (val < 0)
    width--
    temp := -temp
    
  repeat while (temp > 9)
    width--
    temp /= 10
    
  repeat while (width-- > 1)
    term.tx(" ")

  term.dec(val)
    

pub pause(ms) | t

'' Delay program ms milliseconds

  t := cnt - 1088                                               ' sync with system counter
  repeat (ms #> 0)                                              ' delay must be > 0
    waitcnt(t += MS_001)


dat

{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}